package edu.nps.seed.nst

class Resource(n: String) {
	val name = n
	var assignedTask: Task = Task.emptyTask
	var status = ResourceStatus.Available
	var waitingTasks: List[Task] = List()
	var useTime: Double = 0
	var numTasks: Int = 0
	var startTimes: List[Double] = List()
	var endTimes: List[Double] = List()
 
	def startTask(task: Task) {
	    this.assignedTask = task
	    this.status = ResourceStatus.Busy
	    startTimes = TestEvent.currentTime :: startTimes
	    println(TestEvent.currentTime+",resource busy,"+this.name)
	}
 
	def endTask(task: Task) {
	  this.assignedTask = Task.emptyTask
	  this.status = ResourceStatus.Available
	  waitingTasks.foreach(task => Task.scheduleTaskNow(task))
	  waitingTasks = List()
	  useTime += TestEvent.currentTime - startTimes.head
	  endTimes = TestEvent.currentTime :: endTimes
	  numTasks += 1
	  println(TestEvent.currentTime+",resource released,"+this.name)
	}
 
	def addWaitingTask(task: Task) {
	  waitingTasks = task :: waitingTasks
	}
 
	def onTestTime(): Double = {
	  var onTest = 0.
	  if ( !endTimes.isEmpty && !startTimes.isEmpty)
		  onTest = endTimes.head - startTimes.last
   
	  onTest
	  
	}
 
 	override def toString = {
	  name
	}
 
}

object Resource {
	val emptyResource = new Resource("empty")

   def resourceFromXML(node: scala.xml.Node): Resource = {
	   val name = (node \ "name").text
	   var resource = new Resource(name)

	   resource
   }  
}


object ResourceStatus extends Enumeration {
  val Busy = Value("Busy")
  val Available = Value("Available")
}