/*
    
    oldmcdata1.0
    Copyright (C) 2005 Referentia Systems, Inc.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
package oldmcdata.analyzers.utils;

import java.text.NumberFormat;
import java.text.ParseException;

/**
 * @author Stephen C. Upton
 * @date Feb 22, 2005
 *
 */
public class DataVector {
    private String delimiter = ",";
    private String name;
    private double[] values;
    private NumberFormat nf;
    
    public DataVector(String n) {
        name = n;
        nf = NumberFormat.getInstance();
    }
    
    public void setDelimiter(String d) {
        delimiter = d;
    }
    
    public void setValues(String v) {
        Number n = null;
        String[] parsedValues = v.split(delimiter);
        int size = parsedValues.length;
        values = new double[size];
        for (int i=0;i<size;i++) {
            try {
                n = nf.parse(parsedValues[i].trim());
                
            } catch(ParseException pe) {
                System.out.println("beginning of the specified string " + parsedValues[i] + 
                " cannot be parsed; using 0 as default");
                n = new Double(0);
            }
            values[i] = n.doubleValue();
        }

    }
    
    public void setValues(int size, double d) {
        values  = new double[size];
        for (int i=0;i<size;i++) {
            values[i] = d;
        }        
    }
    
    public void setValue(int i, double d) {
        values[i] = d;
    }
    
    public void setValue(int i, String number) {
        Number n = null;
        try {
            n = nf.parse(number.trim());
            
        } catch(ParseException pe) {
            System.out.println("beginning of the specified string " + number + 
            " cannot be parsed; using 0 as default");
            System.out.println(pe.toString());
            n = new Double(0);
        }
        values[i] = n.doubleValue();
    }
    
    public String getName() {
        return name;
    }
    
    public double[] getValues() {
        return values;
    }
    
    public double getValue(int i) {
        return values[i];
    }
    
    public int getSize() {
        return values.length;
    }
    
    public String toString() {
        StringBuffer result = new StringBuffer();
        
        for (int i=0;i<values.length;i++) {
            result.append(values[i]);
            result.append(delimiter);
        }
        result.deleteCharAt(result.length() - 1);
        return result.toString();
    }
    
    
    

}
