package oldmcdata.analyzers.utils.model;

import java.io.IOException;

/**
 * Title:
 * Description:
 *Copyright: 2000 - 2005
 *  
 * @author Stephen C. Upton
 * @version 1.0
 */

public class ManaDataProcessor extends ModelDataProcessor {
    private String headerLine;
    private int numberOfLinesToHeader = 5;

    public ManaDataProcessor() {
        super();
    }


    public void buildSchema() {
        try {
            // use info from first excursion
            fileToProcess = outputDataFileHandler.getDataReader(0);
            skipNumberOfLines(numberOfLinesToHeader);
            headerLine = fileToProcess.readLine();
            moeFormat.buildSchema(headerLine);
            delimiter = moeFormat.getDelimiter();
        } catch (IOException e) {
            e.printStackTrace(System.out);
        }
    }


    protected void processData() {
        try {
            skipNumberOfLines(numberOfLinesToHeader + 1);
            for (int i = 0; i < numberOfReplications; i++) {
                String dataLine = fileToProcess.readLine();
                tokenizeDataLine(dataLine);
                selectData();
            }
            convertData();
            fileToProcess.close();
            selectedData.clear();
        } catch (IOException e) {
            e.printStackTrace(System.out);
        }
    }
}