package oldmcdata.analyzers.utils.stats;


/**
 * Title:
 * Description:
 *Copyright: 2000 - 2005
 *  
 * @author Stephen C. Upton
 * @version 1.0
 */

public class Mean extends AbstractStatistic {

    public Mean() {
        super("Mean");
    }

    public void calculateStatistic(double[] data) {
        double sum = 0.;
        int size = data.length;
        int nanCount = 0;

        for (int i = 0; i < size; i++) {
        	if ( Double.isNaN(data[i]) )
        		nanCount++;
        	else
        		sum += data[i];
        }
        
        if ( nanCount == size )
        	setStatistic(Double.NaN);
        else
        	setStatistic(sum / (double) size);
    }
}