/**
 * 
 */
package oldmcdata.evaluators.LSF;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.dom4j.Element;

/**
 * @author Stephen C. Upton
 * @version 1.0
 */
public class LSFSubmitFileCreator {
	private final static String lineSeparator = System.getProperty("line.separator");
    private File submitFile;
    private List<String> lsfLines;
    private final static String space = " ";
    
    
	public LSFSubmitFileCreator() {
		lsfLines = new ArrayList<String>();	
		lsfLines.add("#!/bin/csh");
		lsfLines.add("#BSUB -q standard");
		lsfLines.add("#BSUB -n 1");
		lsfLines.add("#BSUB -W 01:00");
		lsfLines.add("#BSUB -J job_name");
		lsfLines.add("#BSUB -o job_name.out.dat");
		lsfLines.add("#BSUB -e job_name.err.dat");
		lsfLines.add("#BSUB -a SMP");
		lsfLines.add("cd $WORK_DIR");
		lsfLines.add("archive get -C");
		lsfLines.add("archive get -C pythagoras jaxb-rt-1.0-ea.jar pyth1_10_5.jar");
		lsfLines.add("/app2/java/jdk1.5.0/bin/java  -cp ./pyth1_10_5.jar:./jaxb-rt-1.0-ea.jar com.prototype.terrain.Pyth basecase seed 1 false MOE");
		lsfLines.add("archive put -C study_dir/output MOE ");
		lsfLines.add("exit");
	}

	
    public void createSubmitFile(File studyDirectory, Element lsfElement, int i) {

    	
        submitFile = new File(studyDirectory, "lsfSubmit-" + i + ".dat");
        writeSubmitFile();
    }
    
    public String getSubmitFile() {
        return submitFile.toString();
    }
    
    
    public void writeSubmitFile() {
        try {
            FileWriter fw = new FileWriter(submitFile);
            for (String lsfLine : lsfLines ) {
                fw.write(lsfLine);
                fw.write(lineSeparator);
            }
            fw.close();
        } catch (IOException ioe) {
            System.out.println("Error attempting to open: " + submitFile);
            ioe.printStackTrace(System.out);
            System.exit(-1);
        }
    }
    
}
