package oldmcdata.generators.utils;


import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import nalex.populations.Population;


/**
 * Title:
 * Description:
 *Copyright: 2000 - 2005
 *  
 * @author Stephen C. Upton
 * @version 1.3
 */

/** A class to test implementation of Generators
 */


public class PopulationWriter {
    private File studyDirectory;
    private FileWriter popOutputFile;
    private Map writers;
    private String fileSuffix = ".dat";

    public PopulationWriter(File studyDirectory) {
        this.studyDirectory = studyDirectory;
        writers = new HashMap();
    }

    public void addWriter(String popString) {
        String fileName = popString + fileSuffix;
        File popfile = new File(studyDirectory, fileName);
        writers.put(popString, popfile);
    }

    public void writePopulation(Population pop, String whichPop) {
        File outFile = (File) writers.get(whichPop);
        if (outFile == null) return;
        try {
            popOutputFile = new FileWriter(outFile.toString(), true);
            pop.setName(whichPop);
            popOutputFile.write(pop.toSimpleString());
            popOutputFile.close();
        } catch (IOException e) {
            e.printStackTrace(System.out);
        }
    }

}





