/**
 * 
 */
package oldmcdata.utils.xml;

import java.util.Iterator;
import java.util.List;

import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.InvalidXPathException;
import org.dom4j.Node;

/**
 * @author stephen upton
 * @date 12/23/07
 *
 */
public class XPathReplacementHandler {
	private Document xpathsDoc,scenarioDoc;
	private Element root, replacementElement;
	private String replacementType;
	private int totalNodesModified = 0;
	
	public XPathReplacementHandler() {
		
	}
	
	public void setDocumentRoot(Element root) {
		this.root = root;
	}
	
	@SuppressWarnings("unchecked")
	public void processXpathsToReplace(Element xpathsToReplaceElement) {
		replacementElement = xpathsToReplaceElement.element("ReplaceWith");
		replacementType = replacementElement.attributeValue("type");
//		System.out.println("ReplaceWith: " + replacementElement.asXML());

		Element xpathsElement = xpathsToReplaceElement.element("Xpaths");
		List<Element> xpaths = xpathsElement.elements("Xpath");


		
		//now make all the modifications with valid xpaths
		for (Element xpathElement : xpaths ) {
			modifyXPaths(xpathElement.getTextTrim());
//			System.out.println("xpath read in: " + xpathNode.getText());
		}
	}
	
	@SuppressWarnings("unchecked")
	public void modifyXPaths(String xpathExpression) {
		List<Node> nodeList = null;
		try {
			nodeList = root.selectNodes(xpathExpression);
		}
		catch (InvalidXPathException ixe) {
			System.out.println(ixe.getMessage());
			return;
		}

		if ( nodeList == null || nodeList.size() == 0 ) {
			System.out.println("No nodes match this xpath as specified: " + xpathExpression);
			return;
		}
		totalNodesModified += nodeList.size();
//		System.out.println("Number of nodes in list: " + nodeList.size() + " for xpath: " + xpathExpression);
		for (Node node : nodeList ) {
			replaceNode(node);
//			System.out.println("Node value: " + node.asXML());
		}
	}
	
	private void replaceNode(Node node) {
//	    if ( replacementType.equalsIgnoreCase("element")) {
//	        replaceNodeWithElement(node);
//	        return;
//	    }
	    if ( replacementType.equalsIgnoreCase("text")) {
	        replaceNodeWithText(node);
	        return;
	    }
//	    if ( replacementType.equalsIgnoreCase("factor")) {
//	        replaceNodeWithTextByFactor(node);
//	        return;
//	    }	
//	    if ( replacementType.equalsIgnoreCase("add")) {
//	        replaceNodeWithTextByAdd(node);
//	        return;
//	    }		    
//	    if ( replacementType.equalsIgnoreCase("null")) {
//	        replaceNodeWithNull(node);
//	        return;
//	    }
	}
	
	private void replaceNodeWithText(Node node) {
	    String replacementText = replacementElement.getTextTrim();
	    node.setText(replacementText);
	}
}
